package com.smith9.geiger.client

import com.smith9.geiger.client.beans.Count
import com.smith9.geiger.client.beans.Stat
import groovy.xml.MarkupBuilder
import simplygroovy.csv.opencsv.OpenCsvWriter
import simplygroovy.csv.CsvWriter
import org.joda.time.format.ISODateTimeFormat

/**
 * Created: 7/03/12
 * @author david
 */
class CountCsvConverter {
    String toCsv(List<Stat> stats) {
        StringWriter writer = new StringWriter()
        CsvWriter csv = new OpenCsvWriter(writer)

        csv.writeRow(["productName", "subProduct", "environment", "category", "subCategory", "periodStart", "period", "count", "min", "max", "sum", "failure"])
        stats.each { Count countObj ->
            countObj.with {
                csv.writeRow([productName, subProduct, environment, category, subCategory, periodStart.toString(ISODateTimeFormat.dateTime()), period, count, min, max, sum, failure])
            }
        }
        csv.close()
        return writer.toString()
    }
}
